#!/usr/bin/perl
# toolvars      *** included perl script
#
# @(#)toolvars  12-11-1997
#
# 1996-11-27: add 'mfconcom'-var 'REL' for 'cbackup'
# 1994-01-20: let "OPTIMIZE" depend on "VMAKE_VERSION"
#
# included by several shell scripts, defines system specific values
#
use Env;
use POSIX;

if ($RELVER eq "")
{
	print "\n!!! WARNING:  RELVER not set!!!\n";
	exit 1;
}

if (! $ENV{INSTROOT})
{
	print "\n!!! WARNING:  INSTROOT not set!!!\n";
	exit 1;
}

$ADABAS_COPYRIGHT="Copyright  SAP AG 1997";
if ($RELVER eq "R61") {
	$ADABAS_VERSION="6.1";
}
elsif ($RELVER eq "R62") {
	$ADABAS_VERSION="6.2";
}
elsif ($RELVER eq "R70") {
	$ADABAS_VERSION="7.0";
}
elsif ($RELVER eq "R71") {
	$ADABAS_VERSION="7.1";
}
elsif ($RELVER eq "R72") {
	$ADABAS_VERSION="7.2";
}
elsif ($RELVER eq "R73") {
	$ADABAS_VERSION="7.3";
}


$SQLVERSION="REL30";$ENV{SQLVERSION} = $SQLVERSION; # export $SQLVERSION

$OSSPEC=HPUX;
$ENV{OSSPEC} = $OSSPEC;		# export $OSSPEC
#
 if ($ENV{BIT64} eq "1") {
   $MACH = "PA20W";
 } else {
   if ( defined $ENV{MACH} ) {
     $MACH = $ENV{MACH};
     if ( $MACH eq "PA20W" ) {
       $ENV{BIT64} = "1";
	 } else {
       delete $ENV{BIT64};
	 }
   } else {
	 $MACH = "PA11";
     delete $ENV{BIT64};
   }
 }
#
# End of OSSPEC = HPUX specific MACH/BIT64 settings...
#
$ENV{MACH} = $MACH;		# export $MACH
$OS = "UNIX";
$ENV{OS}         = $OS;			# export $OS



# CTS 1106697
unless ( $ENV{OS_VER} && $ENV{OS_REL} )
{
    local ($os_sysname, $os_nodename, $os_release, $os_version, $os_machine ) = POSIX::uname();
    $ENV{OS_VER} = $os_version;
    $ENV{OS_REL} = $os_release;
}
$OS_VER = $ENV{OS_VER};
$OS_REL = $ENV{OS_REL};


if ($ENV{BIT64} eq "1") {
	$TOOL_LIB = "$TOOL/lib/lib64";
} else {
	$TOOL_LIB = "$TOOL/lib";
}
$ENV{TOOL_LIB} = $TOOL_LIB;

$COMP="PTOC";
if ($RELVER eq "R61") {
	#@CONCOMOPTS = ( "-REL=R61" );
	@CONCOMOPTS = ( "-$SQLVERSION=1", "-REL=R61" );
	#@CONCOMOPTS = ( "-SAG=1", "-$SQLVERSION=1", "-REL=R61" );
}
else
{
	#@CONCOMOPTS = ( );
	@CONCOMOPTS = ( "-$SQLVERSION=1" );
	#@CONCOMOPTS = ( "-SAG=1", "-$SQLVERSION=1" );
}
push @CONCOMOPTS, "-RELVER=$RELVER";
push @CONCOMOPTS, "-DIAGNOSE=1" if defined( $ENV{DIAGNOSE} );
#
# Used for all systems using 64 bit compilation!
#
if ( $ENV{BIT64} eq "1" )
{
	push @CONCOMOPTS, "-BIT64=1";
}
# jrg 2.9.1999

if ( not $CC )
{
    $CC = "cc";
}
#else take CC from the environment
if ( not $CXX )
{
	$CXX = "aCC";
}
#else take CXX from the environment PTS 1001861

if (($RELVER ge "R72") && ($RELVER ne "RTOOL"))  # &gar PTS 1002110
{
	$LD = $CXX;
}
else
{
	$LD	= $CC;
}
# jrg 2.9.1999
# For relocatable objects (collection of object files) a different linker is used
# These definitions replace former system dependend setting in linkrel.pl!
#
# WIN32 uses $AR and $ARFLAGS...
$LDREL = "ld";

if ($MACH eq "HP9")
{
	$AS		= "as";
}
elsif (($MACH eq "PA11") || ($MACH eq "PA20W"))
{
	$AS		= $CC;
}
$AR		= "ar";
$NULL = "/dev/null";
# set C and CXX as environment variable
$ENV{CC}=$CC;
$ENV{CXX}=$CXX;
#
# Additional compiler flags may be set temporary in the environment
# before calling vmake.
#

@ASFLAGS = ();

# 98/06/19 &gar: for differences between C and C++-Compiling in UNIX !
# @CCFLAGS   -> FLAGS for both ( C, C++ )
# @CFLAGS    -> FLAGS for C only
# @CXXFLAGS  -> FLAGS for C++ only
  @CXXFLAGS = split /\s+/, $CXXFLAGS;
  @CFLAGS = split /\s+/, $CFLAGS;
@CCFLAGS = split /\s+/, $CCFLAGS;
push @CCFLAGS, "-D$SQLVERSION",  "-D$OSSPEC", "-D$MACH", "-DSAG";
push @CCFLAGS, "-DDIAGNOSE" if defined( $ENV{DIAGNOSE} );
@CCMODEANSI = ();
@CCMODENORM = ();
@CCMODELINT = ();


# RTS 1000166
@EXCEPT_FLAG = ();

  if (( $RELVER ge "R72") && ($RELVER ne "RTOOL")){

       push @CCFLAGS, "-D_REENTRANT", "-I$INSTROOT/incl", "-I$WRK/incl";

#
# 24.3.2000 Additional include directories for 73...
#
	  if ( $RELVER ge "R73" ) {
#
# Some day this can be removed again if we can use src/SAPDB as new src...
#
		push @CCFLAGS, "-I$WRK/incl/SAPDB";
#
# Using Standard HP OS RogueWave STL
#
	  }

  } else {
#
# older versions ( < V7.2 ) do not support multithreading in any way...
#
    push @CCFLAGS, "-I$INSTROOT/incl", "-I$WRK/incl";

  }

if ($MACH eq "HP9") {
	@LINTFLAGS = @CCFLAGS;
#PTS 1105844
#PTS 1106628
    if (( $RELVER ge "R72") && ($RELVER ne "RTOOL")){
		push @CCFLAGS, "+DA1.0", "+DS1.0", "-Dunix", "-D_FILE_OFFSET_BITS=64";
		push @CFLAGS, "";
	} else {
		push @CCFLAGS, "+DA1.0", "+DS1.0", "-Dunix";
		push @CFLAGS, "-D_FILE_OFFSET_BITS=64";
	}
	@CCMODEANSI = ("-Ae");
	@CCMODELINT = ("-Ae");
	@CCMODENORM = ("-Ae");
	if ( $RELVER ge "R73" ) {
# force strict ansi scope rules
		push @CXXFLAGS, "-Aa";
	}
} elsif ($MACH eq "PA11") {
	push @CCFLAGS, "-DHP9";
#PTS 1105844
	push @CCFLAGS, "+DA1.1", "+DS2.0", "-Dunix", "-D_FILE_OFFSET_BITS=64";
	push @CFLAGS, "";
	@CCMODEKR = ("-Ac", "-D_HPUX_SOURCE");
} elsif ($MACH eq "PA20W") {
	push @CCFLAGS, "-DHP9";
	push @CCFLAGS, "+DA2.0W", "+DS2.0", "-Dunix", "-DBIT64";
	@CCMODEKR = ("-Ac", "-D_HPUX_SOURCE");
	push @ASFLAGS, "+DA2.0W", "+DS2.0";
}



# "OPTIMIZE" now depends on "VMAKE_VERSION" (needed on AIX)
if ($CURR_VERSION =~ /^f/i) {
    # the old value, it was used for everything
    if ($MACH eq "HP9") {
        @OPTIMIZE = "+O2";
    } elsif ($MACH eq "PA11") {
		@OPTIMIZE = ("+O2", "+Olibcalls");
    } elsif ($MACH eq "PA20W") {
	    @OPTIMIZE = ("+O2", "+Olibcalls");
	}
}
elsif ($CURR_VERSION =~ /^q/i) { 	@OPTIMIZE = "+O2" }
else {
    # VMAKE_VERSION is quick or slow
    # one level less than fast - not yet really tested
    # the idea is to combine range checks with less risky code
    @OPTIMIZE = "+O2";
    if ( $CURR_VERSION =~ /^s/ )
    {
	    push @CCFLAGS, "-DASSERTION_PROFILE=SAPDBERR_EXCEPTION_CODE";
    }
}

# CTS 1103440
@DEBUG_FLAGS = ("-g");



# cba 98/07/16 : cause of differeces of C- and C++-Linker
# we may have different linker options on some UNIX-platforms
# we use @LDFLAGS for C-linking and @LDXXFLAGS for C++-Linking
# &gar 99/06/03: for linkdll new variable DLDFLAGS and DLDXXFLAGS
# ( PTS 1103001 )
# initialize
if ($MACH eq "HP9")
{
	@LDFLAGS  = @LDXXFLAGS = ("+DA1.0", "+DS1.0" );
	push @LDXXFLAGS, "-ldld";
	push @LDFLAGS, "-Wl,-a,archive_shared", "-ldld";
	@KLDFLAGS = ("+DA1.0", "+DS1.0", "-Wl,-a,archive");
	@DLDFLAGS  = @DLDXXFLAGS = ("-Wl,-b");
}
elsif ($MACH eq "PA11")
{
	@LDFLAGS  = @KLDFLAGS = @LDXXFLAGS = ("+DA1.1", "+DS2.0" );
	@DLDFLAGS = ("+DA1.1", "+DS2.0", "-Wl,-b");
	@DLDXXFLAGS = ("+DA1.1", "+DS2.0", "-b");
}
elsif ($MACH eq "PA20W")
{
	@LDFLAGS  = @KLDFLAGS = @LDXXFLAGS = ("+DA2.0W", "+DS2.0" );
	@DLDXXFLAGS = ("+DA2.0W", "+DS2.0", "-b");
	@DLDFLAGS = ("+DA2.0W", "+DS2.0", "-Wl,-b");
}

#
# For relocatable objects (collection of object files) a different linker is used
# These definitions replace system dependend setting in linkrel.pl!
#
# WIN32 uses AR and AS_FLAGS
#
# SUN:
# There is no specific option that tells ld   to  link  64-bit
# objects;  the  class of the first object that gets processed
# by ld  determines whether it is to perform  a  32-bit  or  a
# 64-bit link edit.
# AIX:
# 32bit and 64bit relocatable object may even coexist...
#
	@LDREL_FLAGS = ( "-r", "-L$TOOL_LIB" );

# &jrg 14.9.1999
#
# C++ compilation sometimes needs to setup a path to a directory for the template
# cache. In this template cache instances of template functions with external
# linkage are stored.
# Since template instances may differ depending on VMAKE_VERSION (fast,slow...)
# for each version a seperate template cache is forced
#
#
# nothing needed... +inst_all is default. Linker seems intelligent enough to
# eliminate doubled template definitions or produces LOTs of code...
#

# &gar PTS 1001828
@PRF_FLAGS = ();

# &gar OFLAGS for call options
# used in link... and comp...
# always initialize here with ()
@OFLAGS=();

$SR_ID = "static char ident_sr[] =";
$MF_ID = "static char ident_mf[] =";
$PC_ID = "static char ident_pc[] =";
$CC_ID = "static char ident_cc[] =";
$ID_END= ";";

if (($MACH eq "HP9") || ($MACH eq "PA11")) {
	@PCFLAGS= ( "-qn", "-e" );
} elsif ($MACH eq "PA20W") {
	@PCFLAGS= ( "-qn", "-e" , "-64" );
}
@ARFLAGS = ( "rcs" );
$RANLIB = "ar ts";

@LIBPC = ( "$TOOL_LIB/libsqlptc.a" );	# static, not dynamic lib
@LIBPC_PROF = ( "$TOOL_LIB/libsqlptc.a");	# static, not dynamic lib
if ($MACH eq "HP9") {
	@LIBSCR = "-lHcurses";
} else {
	@LIBSCR = "-lcurses";
}
@LIBMATH = "-lm";
@DYNAMIC_LIB = ();
@LIBNET = ();
@LIBCSCI    = ();

#
# PTS 1002837 jrg 26.5.1999
@LIBMPROC = ();

# CTS 1106257
@LIBLD=();

if (( $RELVER ge "R72") && ($RELVER ne "RTOOL")) {
	@LIBAIO = ("-lpthread");
} else {
	@LIBAIO = ();
}

# &gar PTS 1106517
@LDSHMFLAGS=();


if ( $SQLVERSION eq "REL30" )  { $TRACETYPE = "tsp_trace" }
	else { $TRACETYPE = "tracetext" }


#################################################
# vmake environment variables must be set by hand
#################################################

if ( ! $DEVENV ) {
#   $DEVENV = "YES";		# Pascal vsp-modules
    $DEVENV = "NO";			# Assembler or C vsp-modules
}
$ENV{DEVENV} = $DEVENV; # export $DEVENV

undef($CCOMP);
$CCOMP = "GENC";
$ENV{CCOMP} = $CCOMP;
undef($CPPCOMP);
undef($COBCOMP);
undef($FORCOMP);
undef($PASCOMP);


# ================================================================

$DLL_TYPE = "sl";
if (($MACH eq "HP9") ||($MACH eq "PA11")) {
	push @CCFLAGS, "+Z";		# "position independent code" required
}
$ENV{DLL_TYPE} = $DLL_TYPE;		# can be exported even if not set

$ARCH_TYPE = ".a";
$ENV{ARCH_TYPE} = $ARCH_TYPE;		# can be exported even if not set

# PTS 1103820 jrg
# since it can be expected to have python and/or perl already installed
# on the machine, the location of includes and libraries needed can be
# overwritten by environment.
#
if (! $ENV{PYTHON_INCLUDE})
{
	$PYTHON_INCLUDE = $ENV{TOOL} . "/Python/include";
    $ENV{PYTHON_INCLUDE} = $PYTHON_INCLUDE;
}
if (! $ENV{ACTIVEPERL_INCLUDE})
{
	$ACTIVEPERL_INCLUDE = "";
	$ENV{ACTIVEPERL_INCLUDE} = $ACTIVEPERL_INCLUDE;
}
if (! $ENV{ACTIVEPERL_LIB})
{
	$ACTIVEPERL_LIB = "";
	$ENV{ACTIVEPERL_LIB} = $ACTIVEPERL_LIB;
}
if (! $ENV{COREPERL_INCLUDE})
{
	$COREPERL_INCLUDE = $ENV{TOOL} . "/Perl/lib/CORE";
	$ENV{COREPERL_INCLUDE} = $COREPERL_INCLUDE;
}
if (! $ENV{COREPERL_LIB})
{
	$COREPERL_LIB = $ENV{TOOL} . "/Perl/lib/CORE";
	$ENV{COREPERL_LIB} = $COREPERL_LIB;
}

# set installation directory for libraries and scripting interfaces
if ($ENV{BIT64} eq "1")
{
	#all 64-bit-platforms should use lib/lib64
	$ENV{INSTLIB} = $INSTROOT."/lib/lib64";
    $ENV{INSTMISC} = $INSTROOT."/misc/lib64";
} else {
    $ENV{INSTLIB} = $INSTROOT."/lib";
    $ENV{INSTMISC} = $INSTROOT."/misc";
}

$TraceFile = "$WRK/$VMAKE_VERSION/prot/trace.prot";
sub ToolTrace {
	# usage ToolTrace($string, \@daten)
	if ( $ENV{TOOLTRACE}) {
		local( $string, $r_daten ) = @_;
		open( TOOLTRACE, ">>$TraceFile") || die "Can't open $TraceFile (append): $!\n";
		print TOOLTRACE sprintf($string, @$r_daten);
		close(TOOLTRACE);
	}
}


# initializing flush of output buffer
$|=1; print "";
